<?php

  // RIMPS config file

  // System name
  $config["name"] = "::RIMPS 3.0::";

  // Base path of the RIMPS URL
  $config["basedir"] = "/rimps";

  // Path to PHPLIB include files 
  // If phplib is contained in your include path you may leave this commented
  $config["phplib"] = "c:/php/phplib/php/";

  // Enable integrated MP3 scanner (yes/no)
  $config["mp3_scan"] = "yes";

  // Number of songs to display per page.
  $config["num_per_page"] = 10;

  // Width to optimize the for.
  $config["site_width"] = 800;
  
  // Maximum execution time in seconds when rescanning the library.  Use this to prevent
  // run-away processes
  $config['max_rescan_time'] = 300;
  
  // Allow guests to log in (note: guests can only browse the library.  They cannot
  // create, listen to, or download mp3s) (yes/no)
  $config['allow_guest'] = 'yes';
  
  // Allow users with "download" permissions to download mp3s which make up a playlist as
  // .tar files (yes/no)
  $config['allow_download'] = 'yes';
	
	// Maximum download time to allow...  Connection will terminate if it takes longer than this
	// to download a set.  Set this to 0 to allow infinite time.
	$config['max_download_time']=3600; // One hour

  // If you are using the CGI version of PHP, and are using PHP4, there is a bug that prevents 
  // RIMPS from functioning correctly (see bug ID 1546 at bugs.php.net).  Until this problem
  // is solved, you can get around this by setting the paramter below to ''.  However, this may
  // cause some browser compatability problems.  Generally, leave this set to '/my.m3u' if possible.
  // If you get a 500 Internal Server Error, try changing it to an empty string ''...
  $config['playlist_ext'] = '/my.m3u';
  //$config['playlist_ext'] = ''; // Uncomment line this only if you get errors with RIMPS with PHP in CGI mode
  
  
  // DO NOT MODIFY VARIABLES BELOW HERE UNLESS YOU KNOW WHAT YOU ARE DOING

  // Allow friendly moves (yes/no).  If turned on RIMPs will try and preserve the IDs of files
  // which are moved in the library.  Without this option, a moved file will appear as
  // a new song, and another song will be deleted from the database.  This can ruin
  // playlists.  Turning this option on will slow the speed at which your database is
  // rescanned, but not cause the problem described above
  $config['friendly_moves'] = 'yes';

  // Path to image dir
  $config["imgdir"] = $config["basedir"] . "/images";

  // Available listing templates
  $config['available_templates'][] = 'standard';
  $config['available_templates'][] = 'detailed';
  $config['available_templates'][] = 'brief';

  // Index file
  $config["index"] = "index.php";

  // Play one song
  $config["playone"] = "playthis.php";

  // Play playlist
  $config["playlist"] = "playthis.php";

  // Set theme
  $config["settheme"] = "themesiteconf.php";
  
  // Rescan
  $config['rescan'] = 'rescan.php';

  // Search engine
  $config["search"] = "engine/search.inc";

  // Search form
  $config["search_form"] = "layout/search_form.inc";

  // Add to playlist
  $config["submit"] = "engine/submit.inc";

  // Base URL
  $config["baseurl"] = $config["basedir"] . "/" . $config["index"];

  // Format to display time in
  $config["timeformat"]	= "h:i a";

  // Format to display long dates in
  $config["longdateformat"] = "l, F j Y";

  // Format to display dates in
  $config["shortdateformat"] = "m/d/y";

  // Default theme
  $config["defaulttheme"]="blue";
  
  // Number of crumbs to keep track of
  $config['num_crumbs'] = 5;
  
  // Comment out this line if you want to disable the ability
  // to create per-client configuration options
  //require 'config/process_client_config.inc';
  
?>
