<?
// Manage clients connecting to RIMPS

require 'lib/client_management_functions.inc';

if (empty($db)){
	$db = new rimpsDB;
}


if ($deleteClient != ''){
	$sql = "DELETE FROM clients WHERE name = '$deleteClient'";
	$success = $db->query($sql);
	$db->query($sql);
	if ($success){
		rimps_msg("Client Deleted");
	}
	else{
		rimps_error("Could not delete client $deleteClient");
	}
}

if ($addNewClient){
	// Do database work to add a new client:
	//   Make sure only valid chars are used
	//   check to see if row already exists
	//   if yes, update
	//   if no, insert
	if (ereg('^[[:digit:]\.\*]+$', $ip_pattern)){
		// ip_pattern is only digits, ., and * characters
		// Check to see if this name already exists
		$sql = "SELECT name FROM clients WHERE name = '$name'";
		$db->query($sql);
		if ($db->num_rows()<1){
			// Row does not exist... Add it
			$sql = "INSERT INTO clients (name, ip_pattern, priority) VALUES ('$name', '$ip_pattern', $priority)";
			$success = $db->query($sql);
			if ($success){
				rimps_msg("Added client $name");
				$ip_pattern = '';
				$name = '';
				$clientGroup = determineClient();
			}
			else{
				rimps_error("Could not add $name and $ip_pattern");
			}
		}
		else{
			// Name already exists, so do update
			$sql = "UPDATE clients SET ip_pattern = '$ip_pattern', priority=$priority WHERE name = '$name'";
			$success = $db->query($sql);
			if ($success){
				rimps_msg("Updated IP Pattern for $name");
				$clientGroup = determineClient();
			}
			else{
				rimps_error("Failed to update IP Pattern for $name");
			}
		}
	}
	else{
		// Pattern does not contain only valid characters
		rimps_error("IP Pattern can only be numbers and the . and * characters");
	}
}

$theme->edge_title("Clients", $config['site_width']/2);
?>
<center>
<table border=0 cellspacing=5 cellpadding=0>
<tr><td><b>Name</b></td><td><b>IP Pattern</b></td><td><b>Priority</b></td><td></td></tr>
<?
$sql = "SELECT * FROM clients ORDER BY priority DESC";
$db->query($sql);
while($db->next_record()){
	echo "<tr><td>";
	echo $db->f('name');
	echo "</td><td>";
	echo $db->f('ip_pattern');
	echo "</td><td>";
	echo $db->f('priority');
	echo "</td><td>";
	simpleLink($action, "Del", "&deleteClient=".$db->f('name'));
	echo "</td></tr>";
}?>
</table>
</center>
<form action="<?$config['baseurl']?>">
<b>Add new client/client-group:</b><br>

Name: <input type=text name=name value="<?echo $name?>"><br>
IP Pattern: <input type=text name=ip_pattern value ="<?echo $ip_pattern?>"><br>
Priority: <select name=priority>
<?for ($i=0; $i<=3; $i++){
	echo "<option";
	if ($i == $db->f('priority')){
		echo " SELECTED ";
	}
	echo "> $i";
}?>
</select>
<input type=submit name=addNewClient value=Add>
<?include("lib/hidden_fields.inc");?>
</form>
<p>
Give the client or client group a useful name like "Local Network" or "Old Bessie".  These names
will be used when assigning client-specific configurations.<p>
Define the members of the client group with an IP address or an IP address pattern.  Use * as a wild
card.  For example 10.0.0.* would match all IP addresses starting with 10.0.0.  You may only use wild
cards to represent one group of numbers between dots.  For example, 10.* is not a valid pattern.  Instead
use 10.*.*.*
<p>
The each client will only match one pattern.  Priority determines the order in which the current client
is checked to see if there is a match.  If you have a pattern like 10.0.0.* for "local network" but
you'd like to match 10.0.0.5 to a specific client, just give the 10.0.0.5 rule higher priority than
the local network rule.

<?
$theme->edge_title_end();
?>