<?php
// Shows playlist management

require "lib/playlist_functions.inc";

if($perm->have_perm("playlist")){

	if(!$db) $db=new rimpsDB;
	$db2 = new rimpsDB;
	
	if ($action == 'submit'){
		// Handle playlist functions when the user chooses to add or remove songs 
		// from the list		
		
		if ($removePlaylist){
			// The "remove from playlist" button was clicked...
			if (is_array($songid)){
				$song_list = implode(',', $songid);
				$sql = "DELETE FROM playlist_detail WHERE playlist_id = $playlist_id and song_id IN ($song_list)";
				$db->query($sql);
				$systemMessage['submit'] = "Removed ".sizeof($songid)." songs<br>";
			}
			// Set this so that the playlist will be displayed
			$addAndContinue=1;
		}else{
		
			// If the user clicks on "add to new playlist" we have to create a temporary
			// playlist on the fly.
			if ($addNew){
				createNewPlaylist("New ".time());
			}

			for ($z=0; $z < count($songid); $z++){
				// removed check for song already in playlist.  This is enforced via
				// browse/submit additionally, we may want the ability to have dups
				// in playlists at some point

				$db->query("select max(sequence) as max_seq from playlist_detail where playlist_id = " . $playlist_id);
				$db->next_record();
				$seq = $db->Record["max_seq"] + 1;
				$db->query("INSERT INTO playlist_detail VALUES ($playlist_id, $seq, $songid[$z])");
				if($db->affected_rows()){
					$added++;
					$seq++;
				}
				else{
					$failed++;
				}
			}

			$systemMessage['submit'] = "Successfully added ".(int)$added." mp3s<br>\n";
		}
	}

	// Process creation and deletion of playlists if necessary
	if ($action=="addplaylist" and !empty($playname)){
		createNewPlaylist($playname);
	}
	elseif($action=="dellist"){
		deletePlaylist($playlist_id);
		$playlist_id = '';
	}
		
	// Change the name of the playlist if necessary
	if ($oldplaylistname != $newplaylistname){
		$query = "UPDATE playlist SET name = '$newplaylistname' WHERE id = $playlist_id";
		$db->query($query);
	}
	
	// Reorganize the playlists if necessary
	if ($newSubPlaylistID != '' && $playlist_id){
		$query = "UPDATE playlist SET parent = $newSubPlaylistID WHERE id = $playlist_id";
		$db->query($query);
	}
	
	// Get a build an array to identify which playlists are parents
	$sql = "SELECT DISTINCT parent FROM playlist WHERE owner='".$auth->auth["uname"]."' and parent != 0 ";
	$db->query($sql);
	if ($db->num_rows()>0){
		while ($db->next_record()){
			msg("Playlist ".$db->f('parent')." is a parent");
			$playlistParents[$db->f('parent')]=1;
		}
	}
	
	// Find out if the currently selected playlist is a child
	if ($playlist_id){
		$sql = "SELECT parent FROM playlist WHERE id = $playlist_id";
		$db->query($sql);
		while ($db->next_record()){
			$parentID = $db->f('parent');
		}
//		$db->free();
		if ($parentID==0){
			$parentID=$playlist_id;
		}
	}
	
	// Get the children of the current playlist, OR if the current playlist is a child
	// get the children of the parent of the selected list (the selected list's siblings)
	$children = new rimpsDB;
	if ($parentID){
		$sql = "SELECT id, name FROM playlist WHERE parent = $parentID and owner='".$auth->auth["uname"]."'";
		$children->query($sql);
	}
	
	// Get all the playlists
	$db->query("SELECT id, name FROM playlist WHERE parent = 0 and owner='".$auth->auth["uname"]."'");
	
	echo "<table cellspacing=0 callpadding=0 border=0>\n";
	
	while($db->next_record()){
		showPlaylistEntry($db->f('id'), $db->f('name'), $playlist_id);
		
		// If there are children, display them now
		if ($db->f('id')==$parentID && $children->num_rows()>0){
			while($children->next_record()){
				showPlaylistEntry($children->f('id'), $children->f('name'), $playlist_id, 1);
			}
		}
	}
?>
    </td>
  </tr>
    <tr>
      <td nowrap>
        <font size="3">
          <?php createLink("addplaylist", "New"); ?>
          <?createLink("organizeplaylist", "Organize")?>
        </font>
      </td>
  </tr>
</table> 

<?php
}?>



