<?php
//
/// Utility functions
///

function createuser($username,$password,$name,$email,$perms)
{
	global $perm,$auth,$HTTP_POST_VARS,$nr_users,$config;

	// Do we have permission to do so?
	if ($nr_users!=0 && !$perm->have_perm("admin"))
	{
		rimps_error("You do not have permission to create users.");
		return(false);
	}
	// Get a database connection
	$class = $auth->database_class;
	$db = new $class;
	
	// Do we have all necessary data?
	if (empty($username) || empty($password))
	{
		rimps_error("Please fill out <B>username</B> and <B>password</B>!");
		return(false);
	}
	/*
	if (! ( $access_mode == "file" || $access_mode == "url")){
		rimps_error("Invalid value <b>\"$access_mode\"</b>in <B>access_mode</B>!");
		return(false);
	}
	*/
	
	// Does the user already exist?
	// NOTE: This should be a transaction, but mysql does not support transactions...
	
	$db->query("SELECT * FROM ".$auth->database_table." where aid='$username'");
	if ($db->nf()>0)
	{
		rimps_error("User <B>$username</B> already exists!");
		return(false);
	}
	
	if(is_array($perms))
		$new_perms=implode($perms,",");
	
	// Create a uid and insert the user...
	$u_id=md5(uniqid($hash_secret.time()));
	$query = "INSERT INTO ".$auth->database_table." (uid,aid,pwd,perms,name,email) values ".
		"('$u_id','$username','$password','$new_perms','$name','$email')";
	$db->query($query);
	if ($db->affected_rows() == 0) {
		if($perm->have_perm("admin"))
			rimps_error("<b>Failed:</b> $query");
		else
			rimps_error("<b>Failed:</b> updating user ". ($username?$username:$u_id));
		return(false);
	}
	/*
	if ($nr_users >0){
		rimps_msg("User \"$username\" created.<BR>");
	}else{
		header("Location: ".$config["index"]);
//		header("Location: http://localhost/");
		page_close();
		exit();
	}
	*/
	return(true);
}

function updateuser($username,$password,$u_id,$name,$email,$perms)
{
	global $perm,$auth,$HTTP_POST_VARS;
	// Get a database connection
	$class = $auth->database_class;
	$db = new $class;
	
	
	// Do we have permission to do so?
	if ( ( !$perm->have_perm("admin")) && ($auth->auth["uid"] != $u_id))
	{
		rimps_error("You do not have permission to change users.");
		return(false);
	}
	
	/*
	if (! ( $access_mode == "file" || $access_mode == "url")){
		rimps_error("Invalid value <b>\"$access_mode\"</b>in <B>access_mode</B>!");
		return(false);
	}
	*/
	
	if(is_array($perms))
		$new_perms=implode($perms,",");
	
	// Handle users changing their own account...
	if (!$perm->have_perm("admin"))
	{
		unset($changes);
		$changes[]="pwd='$password'";
		if(!empty($name))
			$changes[]="name='$name'";
		if(!empty($email))
			$changes[]="email='$email'";
		//$changes[]="access_mode='$access_mode'";
		$query = sprintf("UPDATE %s SET %s where uid='%s'",$auth->database_table,
				 implode($changes,","),$u_id);
		//print "~~~~@#@<br>\n";
		$db->query($query);
		if ($db->affected_rows() == 0)
		{
			//print "=#=#=#=<br>\n";
			if($perm->have_perm("admin"))
				rimps_error("<b>Failed:</b> $query");
			else
				rimps_error("<b>Failed:</b> updating user ". $auth->auth["uname"]);
			//print "=#=#=#=<br>\n";
			return(false);
		}
		rimps_msg("User ". $auth->auth["uname"] ." changed.<BR>");
		$auth->auth_refreshlogin();
		return(true);
	}else{
		// only admins are left.
		// Do we have all necessary data?
		if (empty($username) || empty($password)){
			// this will catch changing others admins passwords.
			rimps_error("Please fill out <B>username</B> and <B>Password</B>!");
			return(false);
		}
	
		// Update user information.
		unset($changes);
		$changes[]="aid='$username'";
		$changes[]="pwd='$password'";
		$changes[]="perms='$new_perms'";
		if(!empty($name))
			$changes[]="name='$name'";
		if(!empty($email))
			$changes[]="email='$email'";
		$query = sprintf("UPDATE %s SET %s WHERE uid='%s'",$auth->database_table,
						 implode($changes,","),$u_id);
		$db->query($query);
		//print "query=$query<br>\n";
		if ($db->affected_rows() == 0){
			rimps_error("<b>Failed:</b> $query");
			return(false);
		}
	
		$auth->auth_refreshlogin();
		rimps_msg("User \"$username\" changed.<BR>");
		return(true);
	}
	rimps_error ("Don't know what to do");
	return false;
}

	
function deleteuser($username,$u_id)
{
	global $perm,$auth,$sess,$config;
	// Get a database connection
	$class = $auth->database_class;
	$db = new $class;
	// do we have permission to do so?
	if ( ( !$perm->have_perm("admin")) && ($auth->auth["uid"] != $u_id))
	{
		rimps_error("You do not have permission to delete users.");
		return;
	}
	
	// Delete that user.
	$query = "DELETE FROM ".$auth->database_table." WHERE uid='$u_id'";
	$db->query($query);
	if ($db->affected_rows() == 0)
	{
			rimps_error("<b>Failed:</b> $query");
		if($perm->have_perm("admin"))
			rimps_error("<b>Failed:</b> $query");
		else
			rimps_error("<b>Failed:</b> deleting user ". ($username?$username:$u_id));
		return;
	}
	if ($auth->auth["uid"]  == $u_id){
		// we deleted ourself -> delete session (force relogin)
		$auth->unauth();
		$auth->nobody=true;
		// save session
		page_close();
		// redirect to fresh main page (logged in as nobody).
		header("Location: ".$config["index"]);
		exit();
	}
	rimps_msg("User \"$username\" deleted.<BR>");
}

function usermodebox($username)
{
	global $sess,$perm,$auth,$op,$action;
	// Get a database connection
	$class = $auth->database_class;
	$db = new $class;
	
	echo "<br>\n";
	$GLOBALS["theme"]->edge_title("Account Preferences",floor($GLOBALS["defwidth"]/2));
	echo "<table border=0 align=\"center\" cellspacing=2 cellpadding=2 width=350>\n";
	$change_pw=1;
	$pw_visible=1;
	
	// Traverse the result set
	$query="SELECT * FROM ".$auth->database_table." WHERE aid='".$auth->auth["uname"]."'";
	$db->query($query);
	$db->next_record();
	include ("engine/user_template.inc");
	echo " </table>\n";
	$GLOBALS["theme"]->edge_title_end();
}

function adminmodebox()
{
	global $sess,$perm,$auth,$op,$action;
	// Get a database connection
	$class = $auth->database_class;
	$db = new $class;
	if (! $perm->have_perm("admin")){
		rimps_error ("You are not allowed to administrate users!");
		return false;
	}
	//----------------------existing users-----------------------------
	$GLOBALS["theme"]->edge_title("Existing Account Preferences",floor($GLOBALS["defwidth"]/2));
	echo " <table border=0 align=\"center\" cellspacing=2 cellpadding=4 width=350>\n";

	$change_perm=1;
	$change_uid=1;
    // Traverse the result set
	$query="SELECT * FROM ".$auth->database_table." ORDER BY aid";
	$db->query($query);
	while ($db->next_record())
	{
		if($db->f("aid")==$auth->auth["uname"]){
			$change_pw=1;
			$pw_visible=1;
		}else{
			$change_pw=1;
			unset ($pw_visible);
		}
		include ("engine/user_template.inc");
	}
	echo "</table>\n";
	$GLOBALS["theme"]->edge_title_end();
	echo "<br><br>";
	create_user_box();
}
	
function create_user_box($perm_list="")
{
	global $sess,$perm,$auth,$action,$PHP_SELF;
	if(is_object($sess))
		$url=$sess->self_url();
	else
		$url=$PHP_SELF;
	//----------------------create a new user-----------------------------
	$GLOBALS["theme"]->edge_title("New Account",floor($GLOBALS["defwidth"]/2));
	echo " <table border=0 align=\"center\" cellspacing=2 cellpadding=4 width=350>\n";
	$change_perm=1;
	$change_pw=1;
	$change_uid=1;
	$new_user=1;
	include ("engine/user_template.inc");
	echo " </table>\n";
	$GLOBALS["theme"]->edge_title_end();
}
?>
