<?php

require 'application.inc';
$db = new rimpsDB;

// Check to see if we need to do an upgrade
$db->Halt_On_Error ='no';
$sql = "SELECT version FROM version";
$rimpsVersion = $db->simple_query($sql);
if ($rimpsVersion != RIMPS_VERSION){
	// We need to do an upgrade!
	echo "<body>";
	include('engine/upgrade.inc');
	exit;
}
$db->Halt_On_Error = 'yes';

// Handle application setup first time it is run
if($action!="first_time"){
	// Initialize page with session, auth, and perms from PHPLIB
	page_open(array("sess"=>"rimpsSess", 'auth' => 'rimpsAuth', 'perm' => 'rimpsPerm'));
}
else{
	// Simpler just to include this now and abort from the rest of the page.  It gets weird since
	// we don't have a true session or auth object...
	writeThemedBodyTag();
	include ("engine/first_time.inc");
	exit;
}

// Handle logout
if($argv[0]=="logout"){
	//if ($sess) $sess->delete();
	if($auth)
		$auth->logout();
	page_close();
	//page_open(array("sess"=>"rimpsSess"));
	header("location: ".$config['baseurl']);
	// Clear persistent login cookies
	setcookie('persistent_password', '', time(),'/');
	setcookie('persistent_username', '', time(),'/');
	exit;
}

// Set new playlist_id if one was passed in.
if($HTTP_GET_VARS["playlist_id"]!=''){
	// Security check... Does the user own this playlist?
	$db = new rimpsDB;
	$sql = "SELECT id FROM playlist WHERE id = ".$HTTP_GET_VARS["playlist_id"]." AND owner = '".$auth->auth['uname']."'";
	$security_check = $db->simple_query($sql);
	if ($security_check == $HTTP_GET_VARS["playlist_id"]){
		$playlist_id=$HTTP_GET_VARS["playlist_id"];
	}
	else{
		echo "Security violation.  You are not the owner of playlist ".$HTTP_GET_VARS["playlist_id"];
	}
}

// Set the template preference if one was passed in
if ($new_template){
	$templatePreference = $new_template;
}


// if 'selectAll' option has been chosen, then the user wants to select all
// matches while browsing or searching, just as if she had checked the box next
// to each one.  The query which defines which
// songs where matched is in the session variable $totalResultSetQuery

if ($whichFiles == 'selectAll' && $totalResultSetQuery){
	// Since I moved this code up here instead of in play_man.inc we probably don't
	// need to set this variable any more
	$selectAll =1;

	// TODO: Just to be safe would probably be a good idea to run some checks on this query.
	// Even though it came from the session, it is still possible this could be abused and
	// a malicious query is passed in somehow.
	$db = new rimpsDB;
	msg("TotalResultSetQuery: $totalResultSetQuery");
	$songid = array();
	$query = "SELECT id $totalResultSetQuery";
	//echo "totalResultSetQuery: $totalResultSetQuery <br>\n";
	$db->query($query);
	if ($db->num_rows()>0){
		while ($db->next_record()){
			$songid[] = $db->f('id');
		}
	}
}

// Build a list of songs that belong to the array of artists found in $selectedArtists
if (is_array($selectedArtists)){
	// Get songs for these artists
	include('lib/filter_functions.inc');
	msg("selectedArtists: $selectedArtists");
	$artistList = implode("','", $selectedArtists);
	msg("artistList: $artistList");
	$artistList = "'$artistList'";
	$sql = "SELECT id FROM mp3data WHERE artist in ($artistList) ".processFilters($filters);
	msg("select all artist: $sql");
	$db->query($sql);
	while($db->next_record()){
		$songid[] = $db->f('id');
	}
}


// Build a list of songs that belong to the array of alums found in $selectedAlbums
if (is_array($selectedAlbums)){
	// Get songs for these albums
	// We should have album|artist
	reset($selectedAlbums);
	$albumList = '';
	$artistList = '';
	while(list($tmp, $value) = each($selectedAlbums)){
		list($album, $artist) = explode('|', $value);
		$albumList .= "'".$album."',";
		$artistList .= "'".$artist."',";
	}
	$albumList = substr($albumList, 0, strlen($albumList)-1);
	$artistList = substr($artistList, 0, strlen($artistList)-1);
	include('lib/filter_functions.inc');
	msg("artistList: $artistList");
	$sql = "SELECT id FROM mp3data WHERE album in ($albumList) AND artist IN ($artistList) ".processFilters($filters)." ORDER BY artist, album, track";
	msg("select all album: $sql");
	$db->query($sql);
	while($db->next_record()){
		$songid[] = $db->f('id');
	}
}

// Process input and set global variables which will dictate what happens
// further down
if ($doWhat == 'addNew'){
	$addNew =1;
}
elseif($doWhat == 'removePlaylist'){
	$removePlaylist =1;
}
elseif ($doWhat == 'playSongs'){
	//msg("Redirecting to playsongs");
	// Make a list of songs
	if (is_array($songid)){
		$id = implode(',', $songid);
		header("Location: ".$config['playlist'].$config['playlist_ext']."?id=$id");
		exit;
	}
}

// Tell browsers not to cache us.
Header("Pragma: no-cache");
Header("Expires: Tue Jan 26 09:38:24 EST 1999");
require 'layout/html_header.inc';

// Write Body Tag
writeThemedBodyTag();
msg("ClientConfigRules: $clientConfigRules");
require 'layout/header.inc';
require 'layout/crumbtrail.inc';
msg("persistent user: $persistent_username<br>");
msg("persistent password: $persistent_password<br>");
?>

<table border="0" cellspacing="0" cellpadding="0" width="<?php echo $config["site_width"]?>">
<tr>

	<td valign="top">
		<br>
<?php
$GLOBALS["theme"]->edge_title($auth?"Playlists":"Login",$GLOBALS["defwidth"]/3);
//if ($auth && $auth->auth["uname"]!="")
msg("showLoginForm: $showLoginForm");
if ($showLoginForm){
  msg("Showing login form");
  include("engine/login.inc");
}
else{
  include("engine/play_man.inc");
}
echo "</center>";
$GLOBALS["theme"]->edge_title_end();
?>
		<br>
<?php
$config=$GLOBALS["config"];
$GLOBALS["theme"]->edge_title("Search",$GLOBALS["defwidth"]/3);

require $config[search_form];
$GLOBALS["theme"]->edge_title_end();
?>
<br>
<?php
  $GLOBALS["theme"]->edge_title("Menu",$GLOBALS["defwidth"]/3);
include("layout/menu.inc");
$GLOBALS["theme"]->edge_title_end();?>
	</td>
<?php /*-------------------- MIDDLE CONTENT --------------------------------*/?>
	<td valign="top" align="center" nowrap>
<?php
//print "action=$action<br>\n";
if (!$action)
{
  include("engine/main.inc");
}
else
{
  // Make sure action does not contain / or .. or \ characters.  This could be someone
  // trying to access files they should not
  if (strstr($action, '/') || strstr($action, '..') || strstr($action, '\\')){
    include("engine/badAction.inc");
  }
  else{
  	include("engine/$action.inc");
  }
}
?>
	</td>
</tr>
</table>

<?php /*------------------- FOOTER --------------------------------------*/?>
<hr noshade>
<table width="100%" cellpadding="1" cellspacing="1">
<tr>
	<td align="left">
		<a href="http://rimps.sourceforge.net">
		<font size="-3">RIMPS</font></a>
		<font size="-3">Copyright 2001 Robert Dale, Ian O'Neal and Brett Error.</font>
	</td>
	<td></td>
	<td align="right">
		<font size="-3">
		<p align="right">
		<?php
		if ($isearch)
		{
		  echo $isearch;
		  echo " results in ";
		}
		else
		{
		  echo "Processing time: ";
		}
		$end_time = get_proc_time();
		echo $end_time - $proc_time;
		echo "secs.";
		?>
		</p>
		</font>
	</td>
</tr>
</table>

<body>
</html>
<?
page_close();

?>
