<?
/////////////////////////////////////////////////////////////////////////////////////////////////
// Create navigation for the various means of browsing... For alpha, a list of numbers and letters
// for genre a list of genres, etc. 

if($sort=="alpha")
{
	// Create numbers 0 - 9
	for($i=48; $i<=57; $i++)
	{
		if ($i == $index)
			createLink("browse", "<b><font size=+2>" . chr($i) . " </font></b>", $browse, $sort, $i);
		else
			createLink("browse", "<font size=-1>" .chr($i) . "</font> ", $browse, $sort, $i);
	}
	
	// Create alphabet a - z
	for($i=65; $i<=90; $i++)
	{
		if ($i == $index)
			createLink("browse", "<b><font size=+2>" . chr($i) . " </font></b>", $browse, $sort, $i);
		else
			createLink("browse", "<font size=-1>" .chr($i) . "</font> ", $browse, $sort, $i);
	}

}
elseif($sort=="year")
{
	$query = "SELECT distinct year FROM mp3data WHERE 1=1 ".processFilters($filters)." ORDER BY year";
	//print "query=$query<br>\n";
	$db->query($query);
	
	$num_columns = 12;
	
	echo "<table>";
	
	for($i=1; $db->next_record(); $i++)
	{
		if(($i % $num_columns) == 0)
			echo "<tr>";
		echo "<td>";
		createLink("browse", $db->Record[0], $browse, $sort, $db->Record[0]);
		echo "</td>";
		if (($i % $num_columns) == $num_columns - 1)
			echo "</tr>";
	}
	echo "</table>";
}
elseif($sort=="genre")
{
	$query = "SELECT genre, count(*) as number FROM mp3data WHERE genre IS NOT NULL ".processFilters($filters)." GROUP BY genre ORDER BY genre";
	msg ("Palette query: $query");
	$db->query($query);
	
	$num_columns = 5;
	
	//print "query=$query<br>\n";
	echo "<table>";
	for($i=0; $db->next_record(); $i++)
	{
		if(($i % $num_columns) == 0)
			echo "<tr>";
		echo "<td>";
		echo "<font size=-1>";
		createLink("browse", $db->Record[0]. ' ('.$db->f('number').')', $browse, $sort, rawurlencode($db->Record[0]));
		echo "</font>";
		echo "</td>";
		if (($i % $num_columns) == $num_columns - 1)
			echo "</tr>";
	}
	echo "</table>";
}
elseif ($sort == 'added'){

	msg ("Entering added");
	$weekOfSeconds = 7*24*60*60;
	$now = time();
	if ($dbconfig['sqlserver'] == 'mysql'){
		$sql = "SELECT count(*) as number, floor(($now-added)/$weekOfSeconds) AS week FROM mp3data WHERE added is NOT NULL ".processFilters($filters)." GROUP BY week ORDER BY week";
	}
	else{
		// PostgreSQL doesn't support "floor"
		$sql = "SELECT count(*) as number, $now-added)/$weekOfSeconds AS week FROM mp3data WHERE added is NOT NULL ".processFilters($filters)." GROUP BY week ORDER BY week";
	}

	msg("browse palette sql: $sql");
	$db->query($sql);
	
	$num_columns = 5;
	
	echo "<table>";
	echo "<tr><td colspan=$num_columns>";
	echo "Weeks ago the song was added:";
	echo "</td></tr>";
		for($i=0; $db->next_record(); $i++){
			if(($i % $num_columns) == 0)
				echo "<tr>";
			echo "<td>";
			echo "<font size=-1>";
			
			// $index should be set to the earliest time we'd like to look back and a time window
			// in seconds separated by a | character.  For example to look for songs added at most a week ago with a time window
			// of a week the following example applies:
			// Assume current UNIX time is 984267113 we would put 983662313 (which is 984267113 - one week worth of seconds (604800))
			// followed by a | character.  Since a week is the time frame we would then include 604800 (one week of seconds)
			// for a final value of index = 983662313|604800
			
			// First part
			$indexValue = time() - ($db->f('week')+1) * $weekOfSeconds;
			
			// Add window
			$indexValue .= "|$weekOfSeconds";
			createLink("browse", floor($db->f('week')). ' ('.$db->f('number').')', $browse, $sort, rawUrlEncode($indexValue));
			echo "</font>";
			echo "</td>";
			if (($i % $num_columns) == $num_columns - 1)
				echo "</tr>";
		}
		echo "</table>";
	}
elseif($sort == 'popularity'){
	$sql = "SELECT MAX(hits) FROM mp3data WHERE 1=1 ".processFilters($filters);
	$maxHits = $db->simple_query($sql);
	$divUnit = $maxHits / 4;
	$divisions[0] = 'Never';
	$divisions[ceil($divUnit)]  = 'Rarely';
	$divisions[ceil($divUnit*2)] = 'Seldom';
	$divisions[ceil($divUnit*3)] = 'Often';
	$divisions[ceil($divUnit*4)] = 'Frequently';
	echo "<font size=-1>Played: ";
	reset($divisions);
	$prevLimit=0;
	while(list($limit, $text) = each($divisions)){
		$sql = "SELECT count(*) FROM mp3data WHERE hits BETWEEN $prevLimit AND $limit ".processFilters($filters);
		$numSongs = $db->simple_query($sql);
		createLink($action, $text."($numSongs)", $browse, $sort, "$prevLimit|$limit");
		echo "&nbsp;&nbsp;";
		if ($limit == 0){
			$prevLimit=1;
		}
		else{
			$prevLimit=$limit;
		}
	}
	echo "</font>";
}

?>