<?
// Manages and displays a "crumb trail" or history of what a user has been
// doing.  Make site navigation much easier.

if (!is_array($crumbs)){
	$crumbs = array();
}

if ($action == 'browse'){
	$crumb['name'] = "Browse by $browse";
	if ($sort!=''){
		$crumb['name'] .= "/$sort";
		if ($index != ''){
			// Put some meaning behind the index displayed
			if ($sort=='alpha'){
				$indexRep = chr($index);
			}
			if ($sort == 'genre'){
				if (strlen($index) > 8){
					$indexRep = substr($index, 0, 5). '...';
				}
				else{
					$indexRep = $index;
				}
			}
			if ($sort == 'added'){
				// Figure out how many weeks ago this represents
				$weekOfSeconds = 7*24*60*60;
				$now = ceil(time()/$weekOfSeconds);
				$indexRep = $now - ceil($index/$weekOfSeconds);
			}
			$crumb['name'] .= "-$indexRep";
		}
	}
}
elseif($action == 'search'){
	$crumb['name'] = "Search";
	if ($display!=''){
		$crumb['name'] .= " $display=";
		if (strlen($search) > 8){
			$tmp = substr($search, 0, 5);
			$crumb['name'] .= "$tmp...";
		}
		else{
			$crumb['name'] .= $search;
		}
	}
}

$crumb['page'] = $page;
$crumb['sort'] = $sort;
$crumb['search'] = $search;
$crumb['browse'] = $browse;
$crumb['action'] = $action;
$crumb['index'] = $index; 
$crumb['display'] = $display; 

// Reasons to start a new crumb
$newCrumb['action']=1;
$newCrumb['search']=1;
$newCrumb['display']=1;
$newCrumb['browse']=1;

// Look to see if the action of this page is worth creating a new
// crumb as defined by the $newCrumb variable.  Also check to see if
// the action is the same as the last crumb.  If it is, we should just
// update the last crumb, not create a new one.
reset($newCrumb);
while (list($key, $value) = each($newCrumb)){
	if ($crumbs[0][$key] != $$key){
		$new =1;
	}
}

function php_array_unshift(&$array, $new){
	// This funciton exists in PHP4 as array_unshift.  Until we can use it
	// we'll have to fake it with this one
	$temp[] = $new;
	reset($array);
	while(list($key, $value) = each($array)){
		$temp[] = $value;
	}
	$array = $temp;
}

function php_array_shift(&$array){
	// This function exists in PHP4 as array_shift.  Until we can use it
	// we'll fake it with this one
	reset($array);
	while(list($key, $value) = each($array)){
		if (!$return){
			$return = $value;
		}
		else{
			$temp[] = $value;
		}
	}
	$array=$temp;
	return $return;
}

if ($crumb['name'] != '' && !$noNewCrumbs){
	// This is a crumb-worthy event!
	
	// If we ARE creating new crumbs AND the current crumb is not 0 then
	// we need to remove crumbs which were added after the current crumb
	// to maintain the flow.  Otherwise the stream of events gets all weird
	for ($i=0; $i<$currentCrumb; $i++){
		//array_shift($crumbs);
		php_array_shift($crumbs);
	}
	
	// Since we are creating a new crumb, we should also set it to be the active one
	$currentCrumb = 0;
	if ( $new ){
		// In PHP4, this can be done with the array_unshift function
		// until we are committed to PHP4, however, we'll have to do this 
		// ugly work around
		//
		//array_unshift($crumbs, $crumb); 
		php_array_unshift($crumbs, $crumb);
		
		unset($crumbs[$config['num_crumbs']]);
	}
	else{
		// Don't add a new crumb, just update the current one
		$crumbs[0] = $crumb;
	}
}

echo "<font size=-2>";

for ($i=$config['num_crumbs']-1; $i>=0; $i--){
	if ($crumbs[$i]['name'] != ''){
		if ($i == $currentCrumb) {
			echo "<b>";
		}
		echo "<a href=crumbTrail.php?crumbid=$i>";
		echo $crumbs[$i]['name'];
		echo "</a>";
		if ($i == $currentCrumb) {
			echo '</b>';
		}
		if ($i!=0){
			echo  ' &gt; ';
		}
	}
}
echo "</font>";	
/*
reset ($crumbs);
while (list($tmp, $crumb) = each($crumbs)){
	$trail = "<a href=crumbTrail.php?crumbid=$tmp>".$crumb['name'] . "</a> &gt; " . $trail;
}

echo "<font size=-2>$trail</font>";
*/
?>