<?
// New more modular design.  Uses templates now instead of the complex
// nested if statements.  lib/listings_templates/ contains the templates
// available for showing music.  Each template only has the the HTML needed 
// to format a single row of data.  This row will be repeated over and over
// to create the whole listing.  Also, each template needs to be a set.  There 
// should have a version for 
// each "browse" option: title, artist, and album.  The template name
// takes the format: name_browse.inc where name is a unique name, and browse
// is the browse mode.  For example standard_title.inc is the template to use
// when we are using the standard template set, and we are displaying aritsts.
// Each template has a set of variables available to it (open the template
// file lib/listing_templates/standard_title.inc to see a list of the available
// options.  The name of the template which will be used is stored in the variable
// $listingTemplate.  If this variable is left empty, the template will default
// to the name of the template stored in the session in the variable 
// $templatePreference.  

echo "<form action=".$config["index"]." method=get name=submitForm>";
echo "<input type=hidden name=action value=submit>";

// Build array of which variable corresponds to each browse
// parameter.  This var will be put behind the checkbox
$varForBrowse['title'] = 'songid';
$varForBrowse['artist'] = 'selectedArtists';
$varForBrowse['album'] = 'selectedAlbums';

// Build an array mapping the "key" database parameter to each browse
// parameter

$keyDBParam['title'] = 'id';
$keyDBParam['artist'] = 'artist';
$keyDBParam['album'] = 'album';

// For album we need two "keys".  Here is an array that does that just incase
// we have other things in the future which need to pass two keys.
$keyDBParam2['album'] = 'artist';

// Set the listing template
if ($listingTemplate == ''){
	$listingTemplate = $templatePreference;
}

// Buttons...
require "layout/playlist_buttons.inc";

// include the listing template
echo "<table border=0 cellpadding=0 cellspacing=1 width=".($config["site_width"]/1.5);
echo ">";

require 'layout/legend_row.inc';

for($i=0; $db->next_record(); $i++){
	// Load associative array from db into $r.
	$r = $db->Record;
	// Set other variables available to the templates
	if ($i%2){
		$bgcolor = " bgcolor = '".$theme->highlightcolor."' ";
	}
	else{
		$bgcolor = '';
	}
	$checkBox = "<input type=checkbox name='".$varForBrowse[$browse]."[]' value=\"".$r[$keyDBParam[$browse]];
	if ($keyDBParam2[$browse]!=''){
		$checkBox .= '|'.$r[$keyDBParam2[$browse]];
	}
	$checkBox .= "\">";
	if($perm->have_perm("play")){
		$play =  "<a href=".$config["baseurl"]."?doWhat=playSongs&".$varForBrowse[$browse]."[]=".rawURLEncode($r[$keyDBParam[$browse]]);
		if ($keyDBParam2[$browse]!=''){
			$play .= '|'.rawUrlEncode($r[$keyDBParam2[$browse]]);
		}
		$play .= ">Play</a> &nbsp;";
	}
	else{
		$play = '';
	}
	if($perm->have_perm("edit_id3")){
		$edit = createLinkNoPrint("id3_edit", "Edit", $browse,$sort,$args="&id=".$r[$keyDBParam[$browse]]);
	}
	else{
		$edit = '';
	}
	if ($filters['showAvailable'] == ''){
		// The showAvailable system filter is turned off
		if ($r['available']==0){
			$availIcon = '<img src="'.$config['imgdir'].'dot_red.gif">';
		}
		else{
			$availIcon = '<img src="'.$config['imgdir'].'dot_green.gif">';
		}
	}
	else{
		$availIcon = '';
	}
	require "layout/listing_templates/${listingTemplate}_$browse.inc";
}
require "layout/legend_row.inc";
echo "</table>";
require "layout/playlist_buttons.inc";
echo "</form>";

if (is_array($config['available_templates'])){
	$url = "http://".$GLOBALS['HTTP_HOST'].$GLOBALS['config']['baseurl']."?browse=".$GLOBALS['browse']."&page=".$GLOBALS['page']."&search=".urlEncode($GLOBALS['search'])."&index=".$GLOBALS['index']."&sort=".$GLOBALS['sort']."&display=".$GLOBALS['display'];
	if ($GLOBALS['action'] =='submit' || $GLOBALS['action'] =='dellist' ){
		$url .= "&action=".$GLOBALS['formerAction'];
	}
	else{
		$url .= "&action=".$GLOBALS['action'];
	}
	echo '<font size=-2>Choose listing format: ';
	reset($config['available_templates']);
	while(list($tmp, $name) = each($config['available_templates'])){
		echo "<a href='$url&new_template=$name'>$name</a>&nbsp;&nbsp;&nbsp;";
	}
	echo '</font>';
}
?>