<?php
if (!$included["common.inc"])
{

// createLink - create a link by passing some params, easy
//   $action       (req) - we always have an action.  this is the name of the
//                      php engine file which does all the work
//   $link_text    (req) - every link should have _some_ text
//   $browse       (opt) - artist, song, album
//   $sort         (opt) - how to sort a browse category
//   $index        (opt) - 0-9,A-Z
//   $playlist_id  (opt) - current playlist_id
//   $selected     (opt) - this link is selected/active, we should color it
//   $color        (opt) - if defined, use this color, otherwise a default
//   $m3u          (opt) - name of the playlist/m3u
//   $mp3          (opt) - name of the mp3 (only one of mp3 or m3u should be used)
//   $args         (opt) - any extra args we may have forgotten

	function createLink ($action, $link_text, $browse="", $sort="", $index="", $selected="", $color="", $m3u="", $mp3="", $args="")
		{
		echo createLinkNoPrint($action, $link_text, $browse, $sort, $index, $selected, $color, $m3u, $mp3, $args);
	}
	
	function createLinkNoPrint ($action, $link_text, $browse="", $sort="", $index="", $selected="", $color="", $m3u="", $mp3="", $args="")
	{
		
		global $config, $playlist_id, $auth, $sess;
		
		$base = $config[baseurl] . "?action=" . $action;
		if ($browse)
			$base .= "&browse=" . rawurlencode($browse);
		if ($sort)
			$base .= "&sort=$sort";
		if ($playlist_id)
			$base .= "&playlist_id=" . $playlist_id;
		if ($index)
			$base .= "&index=$index";
		if ($args)
			$base .= "&$args";
		if ($m3u)
			$base .= "/" . $m3u . $GLOBALS['config']['playlist_ext'];
		elseif($mp3)
			$base .= "/" . $mp3 . ".mp3";
		if ($selected)
		{
			if ($color)
				$link_text = "<font color=\"$color\">$link_text</font>";
			else
				$link_text = "<font color=\"$color[default]\">$link_text</font>";
		}
		return "<a href=\"$base\">$link_text</a>";
	}
	
	// simpleLink - create a link, give parameters by hand
	//   $action       (req) - we always have an action.  this is the name of the
	//                      php engine file which does all the work
	//   $link_text    (req) - every link should have _some_ text
	//   $args         (opt) - any extra args
	//   $selected     (opt) - this link is selected/active, we should color it
	
	function simpleLink ($action, $link_text, $args="",$selected=""){
			
			global $config, $playlist_id, $auth, $sess;
			
			$base = $config[baseurl] . "?action=" . $action;
			if ($args)
				$base .= "$args";
			if ($selected)
			{
				if ($color)
					$link_text = "<font color=\"$color\">$link_text</font>";
				else
					$link_text = "<font color=\"$color[default]\">$link_text</font>";
			}
			echo "<a href=\"$base\">$link_text</a>";
	}
	
	function size_calc($size)
	{
		if($size>(1024*1024*1024))
			return(number_format($size/(1024*1024*1024),2)." GB");
		elseif($size>(1024*1024))
			return(number_format($size/(1024*1024),2)." MB");
		elseif($size>(1024))
			return(number_format($size/(1024),2)." KB");
		else
			return(number_format($size,2)." B");
	}
	
	function time_calc($sec){
		// Takes a number of seconds and returns the time in hh:mm:ss format.  If
		// there are no hours, then only returns mm:ss.  If no minutes, just returns
		// ss.
		if (!ereg('^[[:digit:]]+$', $sec)){
			return $sec;
		}

		if ($sec >= 3600){
			// At least one hour
			$h = floor($sec/3600);
			$sec = $sec - ($h * 3600);
			$time = "$h:";
		}
		
		if ($sec >= 60){
			// At least one minute...
			$m = floor($sec/60);
			$sec = $sec - ($m * 60);
		}
		if ($time || $m){
			if ($m<10){
				$time = $time . "0$m:";
			}
			else{
				$time = $time . "$m:";
			}
		}
		
		if ($sec < 10){
			$time = $time . "0$sec";
		}
		else{
			$time = $time . $sec;
		}
		
		return $time;
	}

	// 5/12/00 (JKD) This fxn actually exists in PHP4, but I want it now! :-)
	// we'll want to remove it when we migrate to PHP4 or have some way of
	// detecting what version we're running and use it selectively

	// 9/16/00 (IEO) Modified to only define for PHP3.
	if (!function_exists(in_array)) {
		function in_array($needle,$haystack)
		{
			for($i=0;$i<count($haystack) && $haystack[$i] !=$needle;$i++);
                                                           
			return ($i!=count($haystack));
		}
	}


	function writeThemedBodyTag(){
		// Writes a body tag based on the currently selected theme
		
		echo "<body bgcolor=\"".$GLOBALS["theme"]->backgroundcolor."\" ";
		echo "background=\"".$GLOBALS["theme"]->backgroundimage."\" ";
		echo "text=\"".$GLOBALS["theme"]->textcolor."\" ";
		echo "link=\"".$GLOBALS["theme"]->linkcolor."\" ";
		echo "vlink=\"".$GLOBALS["theme"]->vlinkcolor."\" ";
		echo "alink=\"".$GLOBALS["theme"]->alinkcolor."\">";
	}

    // Display error messages
	function rimps_error($msg){
		    ?>
		<?$GLOBALS["theme"]->edge(floor($GLOBALS["defwidth"]/3));?>
		<table border=0 align="center" cellspacing=0 cellpadding=4>
		  <tr>
		    <td><font color=#FF2020>Error: <?php print $msg ?></font></td>
		  </tr>
		</table>
		<?$GLOBALS["theme"]->edge_end();?>
		<BR>
		<?php
	}

    // Display success messages
    	function rimps_msg($msg){
		?>
		<?$GLOBALS["theme"]->edge(floor($GLOBALS["defwidth"]/3));?>
		<table border=0align="center" cellspacing=0 cellpadding=4>
		    <tr>
			    <td><font color=#008000>O.K.: <?php print $msg ?></font></td>
		    </tr>
		</table>
		<?$GLOBALS["theme"]->edge_end();?>
		<br>
		<?php
	}
	
	function makeSearchable($text, $field){
		// creates a link that when clicked on will search for the term
		// $text in the exact_$field.
		$return = '<a href="'.$GLOBALS['config']['baseurl'].'?action=search&display=exact_'.$field.'&search='.rawUrlEncode($text).'">';
		$return .= $text;
		$return .= '</a>';
		return $return;
	}
	
	
	
	
	$included["common.inc"]=1;

}
?>
