<?
// Functions assisting in processing filters

if (!$included["filter_functions.inc"]){

function processFilters($filters){
	if (!is_array($filters)){
		return '';
	}
	
	reset($filters);
	while(list($filter, $query) = each($filters)){
		$modifier[] = $query;
	}
	if (is_array($modifier)){
		$mod = implode(' AND ', $modifier);
		return " AND $mod";
	}
	else{
		return '';
	}
}

function initFilterDB(){
	// Initialized the user's filter database with the system 
	// filters.  This should only be called if the user has NO rows in the
	// filter database.
	
	include 'config/sysfilter_definitions.inc';
	$db = new rimpsDB;
	reset ($sysFilter);
	while(list($name, $values) = each($sysFilter)){
		$sql = "SELECT count(*) FROM filters WHERE aid = '".$GLOBALS['auth']->auth['uname']."' AND sys_name = '$name'";
		$number = $db->simple_query($sql);
		if ($number ==0){
			$sql = "INSERT INTO filters (aid, active, field, relationship, filter_value, value_type, display, sys_name)".
				"values('".$GLOBALS['auth']->auth['uname']."', ".$values['active'].
				", '".$values['field']."', '".$values['relationship']."', '".$values['filter_value'].
				"', '".$values['value_type']."', '".$values['display']."', '".$name."')";
			msg("adding system filter: $sql");
			$db->query($sql);
		}
	}
}

function getAllFilters(){
	// Returns a two-dimensional array of filter data for this user.  The first dimension
	// contains the filter name, the second, all the filter data.  Good to use this function
	// to get all filters because it automatically detects when the filter database has not
	// been properly initialized.
	$db = new rimpsDB;
	$sql = "SELECT * FROM filters WHERE aid = '".$GLOBALS['auth']->auth['uname']."'";
	$db->query($sql);
	if ($db->num_rows()<1){
		// Since initFilterDB is called by auto_init.inc BEFORE we call this function
		// we should never hit this, but I've added it just in case.
		msg("There are no filters for this user.  We should init");
		initFilterDB();
		$sql = "SELECT * FROM filters WHERE aid = '".$GLOBALS['auth']->auth['uname']."'";
		$db->query($sql);
	}
	while($db->next_record()){
		$filters[$db->f('name')] = $db->Record;
	}
	return $filters;
}


function getActiveFilters(){
	// Returns an array of all active filters.  The key of the array is the name of
	// each active filter, and the value is a modifying query to be applied
	$db = new rimpsDB;
	$sql = "SELECT * FROM filters WHERE aid='".$GLOBALS['auth']->auth['uname']."' AND active =1";
	msg("Get active filters query: $sql");
	$db->query($sql);
	if ($db->num_rows()<1){
		// No active filters.  Maybe this user has not yet been initialized with system
		// filters.
		msg("No active filters");
		$sql = "SELECT * FROM filters WHERE aid='".$GLOBALS['auth']->auth['uname']."'";
		$db->query($sql);
		if ($db->num_rows()<1){
			// Since initFilterDB is called by auto_init.inc BEFORE we call this function
			// we should never hit this, but I've added it just in case.
			msg ("No filters at all for this user!");
			// No filters at all.  This user must be initialized
			initFilterDB();
			// Now that filterDB is initialized, repeat the query to get active filters.
			$sql = "SELECT * FROM filters WHERE aid='".$GLOBALS['auth']->auth['uname']."' AND active =1";
			$db->query($sql);
		}
		else{
			// There are filters, just none are active.  Return an empty array
			return array();
		}
	}
	
	while($db->next_record()){
		// Build the filter array which contains the filter name and the query 
		// modifier
		$modifier = $db->f('field')." ".$db->f('relationship')." ";
		if ($db->f('value_type')=='string'){
			$modifier .= "'".$db->f('filter_value')."'";
		}
		else{
			$modifier .= $db->f('filter_value');
		}
		
		if ($db->f('sys_name')){
			$id = $db->f('sys_name');
		}
		else{
			$id = $db->f('id');
		}
		$filters[$id] = $modifier;
	}
	return $filters;
}


$included['filter_functions.inc'] =1;
}

?>