<?php

function SQLString ($string)
{
  $string = addslashes($string);
  return $string;
}

Function sqlsearchstring ()
{ 
  return "^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2})";
}

Function createSqlDate($year, $month, $day) 
{
  return sprintf( "%04d-%02d-%02d", $year, $month, $day);
}

Function createSqlDateTime($year, $month, $day, $hour, $min, $sec) 
{
  return sprintf( "%04d-%02d-%02d %02d:%02d:%02d", $year, $month, $day, $hour, $min, $sec);
}

Function sqlDuringDay($datestr) 
{
  return "start > '$datestr 00:00' AND start < '$datestr 23:59'";
}

Function convertSQLTimetoUTime( $sqldate ) 
{
  return( mktime( substr( $sqldate, 11, 2 ), substr( $sqldate, 13, 2 ), substr( $sqldate, 15, 2 ), substr( $sqldate, 5, 2 ), substr( $sqldate, 8, 2 ), substr( $sqldate, 0, 4 ) ) );
}

Function MakeInsertString ($data) 
{
  while ( list( $key, $val ) = each( $data ) ) 
  {
    if( $val != "--remove" ) 
    {
      $string["fields"] .= "$key, ";
      $string["values"] .= "'" . SQLString($val) . "', ";
    }
  }
  $string["fields"]=ereg_replace(", $","",$string["fields"]);
  $string["values"]=ereg_replace(", $","",$string["values"]);
  return $string;
}

Function MakeUpdateString ($data) 
{
  while ( list( $key, $val ) = each( $data ) ) 
  {
    if ($data[$key]) 
      $strings .= $key . " = '" . SQLString($val) . "', ";
  }
  $strings=ereg_replace(", $", " ", $strings);
  return $strings;
}

Function dbQuery ($statement) 
{
  global $dbconfig;
  //  echo "<p><code>dbQuery: $statement</code></p>";
  // 
  $conn = "host=$dbconfig[sqlhost]";
  if ($dbconfig[sqlport] != "") 
    $conn = $conn . " port=$dbconfig[sqlport]";
  if ($dbconfig[sqlusername] != "") 
    $conn = $conn . " user=$dbconfig[sqlusername]"; 
  if ($dbconfig[sqlpassword] != "") 
    $conn = $conn . " password=$dbconfig[sqlpassword]"; 
  if ($dbconfig[sqldb] != "") 
    $conn = $conn . " dbname=$dbconfig[sqldb]"; 
  // echo "<p><code>Connect string: $conn</code></p>";
  $db=pg_Connect($conn);
  
  if (! $db) 
  {
    PrintError("Could not connect to database");
    return 0;
  }
  $result=pg_Exec($db,$statement);
  if(!$result) 
  {
    pg_ErrorMessage($db);
    echo $statement;
  }
  pg_Close($db);
  return $result;
}

Function dbResult ($result,$i,$field) 
{
  return pg_Result($result,$i,$field);
}

Function dbNumRows ($result) 
{
  if (!$result) 
    return "";
  return pg_NumRows($result);
}

Function dbResultArray ($result,$i) 
{
  if (!$result)
    return "";
  return pg_Fetch_Array($result,$i);
}

Function dbFetchRow ($result,$i) 
{
  if (!$result)
    return "";
  return pg_fetch_row($result,$i);
}
?>
