<?
require($config["phplib"]."db_".$dbconfig["sqlserver"].".inc");
require($config["phplib"]."ct_sql.inc");
require($config["phplib"]."session.inc");
require($config["phplib"]."auth.inc");
require($config["phplib"]."perm.inc");
require($config["phplib"]."page.inc");
  
// Just set something random here.  This string prevents users from guessing what the secret
// authentication key to be passed in (in the case of login information being preserved)...
$server_secret = 'nelclna;lkenlkcg02d';

class rimpsDB extends DB_Sql
{
  var $classname="rimpsDB";
  var $Host;
  var $Database;
  var $User;
  var $Password ;

  function rimpsDB()
  {
    global $dbconfig;
    $this->Host = $dbconfig["sqlhost"];
    $this->Database = $dbconfig["sqldb"];
    $this->User = $dbconfig["sqlusername"];
    $this->Password = $dbconfig["sqlpassword"];
  }
  
  function halt($msg)
  {
    reset($GLOBALS);
    while(list($var,$val)=each($GLOBALS))
      $$var=$val;
    if ($this->Halt_On_Error == "no")
      return;
    printf("</td></tr></table>");
    printf("</td></tr></table>");
    printf("</center><br>");
    $out=sprintf("<b>Database error:</b> %s<br>\n", $msg);
    $out.=sprintf("<b>MySQL Error</b>: %s (%s)<br>\n",
	   $this->Errno, $this->Error);
    $out.=sprintf("Please contact the webmaster and report the ");
    $out.=sprintf("exact error message.<br>\n");
    
    $log_message=$msg."\n";
    $log_message.="Class: ".$this->classname."\n";
    $log_message.="MySQL Error:".$this->Error." (".$this->Errno.")\n";
    if(!empty($php_errormsg) && !eregi("Uninitialized variable",$php_errormsg))
      $log_message.=$php_errormsg."\n";
    if(!empty($PHP_SELF))
      $log_message.="PHP_SELF=$PHP_SELF\n";
    if(!empty($REMOTE_ADDR))
      $log_message.="REMOTE_ADDR=$REMOTE_ADDR\n";
    if(!empty($HTTP_USER_AGENT))
      $log_message.="HTTP_USER_AGENT=$HTTP_USER_AGENT\n";
    if(!empty($SCRIPT_URI))
      $log_message.="SCRIPT_URI=$SCRIPT_URI\n";
    if(!empty($REDIRECT_SCRIPT_URI))
      $log_message.="REDIRECT_SCRIPT_URI=$REDIRECT_SCRIPT_URI\n";
   $this->Debug=1; 
    if($this->Debug)
      print str_replace("\n","<br>\n",$log_message)."<br>\n";
    else
      error_log($log_message,1,$SERVER_ADMIN);
    
    
    if($this->Debug)
      print str_replace("\n","<br>\n",$out)."<br>\n";
    else
    {
      print "<font size=4 class=SIZE4>";
      print "We're very sorry to inform you that there has been an error.<br>\n<br>\n";
      print "Please send the <a href=\"mailto:$SERVER_ADMIN\">admin</a> a detailed report of the situation that caused this error homepage\n";
      print "</font>\n";
    }
    die("Session halted.");
    exit;
  }
  // this is a simple function to just get one element out of the database
  // returns the first field of the result or undefined if nothing found
  function simple_query($query){ 	
    $this->query($query);
    if ($this->next_record()){
      return $primary_key=$this->f("0");
    }else{
      return undef;
    }
  }
}

class rimpsAuth extends Auth
{
  var $classname      = "rimpsAuth";

  var $lifetime       =  1440;

  var $database_class = "rimpsDB";
  var $database_table = "users";
  
  function auth_loginform()
  {
    msg("called auth_loginform()");
    include("engine/login.inc");
    //include("index.inc");
    $GLOBALS['showLoginForm']= true;
  }
  
  function auth_validatelogin()
  {
    global $username, $password, $server_secret;
    msg("validating login");
    if ($username==''){
    	$username = $GLOBALS['persistent_username'];
    }
    
    $this->auth["uname"]=$username;        // This provides access for "loginform.inc"
    
    $uid = false;
    $query=sprintf("SELECT uid, perms, pwd FROM %s WHERE aid = '%s'",
		   $this->database_table,addslashes($username));
    //print "query=$query<br>\n";
    $this->db->query($query);

    // Allow for a guest login
    if ($GLOBALS['logInAsGuest'] && $GLOBALS['config']['allow_guest'] == 'yes'){
    	$uid = 'guest';
    	$username = 'guest';
    }
    else{
	    while($this->db->next_record()) {

	      // Check to make sure passwords match
	      // The second half of this checks to see if the user can be authenticated
	      // off the cookies passed in (if the user checked to save login

	      //echo "persist passwd: ".$GLOBALS['persistent_password']."<br>";
	      //echo "hash: ".md5($this->db->f('pwd').$server_secret)."<br>";
	      //echo "db passwd : " . $this->db->f('pwd') ."::: password: $password";
	      if ($this->db->f('pwd') == $password || md5($this->db->f('pwd').$server_secret) == $GLOBALS['persistent_password']){    
	      //if ($this->db->f('pwd') == $password){
		//echo "user authenticated";
		$uid = $this->db->f("uid");
		$this->auth["perm"] = $this->db->f("perms");
	      }
	    }
    }	
	if ($uid == false)
		$this->auth["error"] = "Either your username or password are invalid.<br>Please try again.";
	else{
		$this->auth['uname'] = $username;
		SetCookie("rimps_user", $username, pow(2, 31)-1, '/');
		// Set cookie to allow automatic login
		if ($GLOBALS['saveLogin']){
			SetCookie('persistent_username', $username, time()+31536000, '/');
			// Lets NOT put the password as a cookie just in case the user also uses it
			// for other sites...  Instead, we'll hash it with a server secret and store that.
			// When authenticating we'll compare what is passed in with a has of the password
			// against server_secret again.
			SetCookie('persistent_password', md5($password.$server_secret), time()+31536000, '/');
			msg("set save-login cookies");
		}
	}

	return $uid;
}
	
  
  function auth_preauth() 
	{
		global $HTTP_COOKIE_VARS;
		if(!empty($GLOBALS["persistent_username"]))
			return($this->auth_validatelogin());
		if ($HTTP_COOKIE_VARS["rimps_user"]) 
		{
			$this->auth["uname"] = $HTTP_COOKIE_VARS["rimps_user"];
			$this->mode = "log";
		}
		return false;
	}


}


class rimpsPerm extends Perm
{
  var $classname = "rimpsPerm";
  
  var $permissions = array(
			   "play"	=>1,
			   "playlist"	=>2,
			   "download"	=>4,
			   //"upload"	=>8,
			   "edit_id3"	=>16,
			   "rescan"	=>32,
			   "admin"	=>65536
			   );
  
  function rimpsPerm ()
  {
    global $SITE_MENU;
    if(is_array($SITE_MENU))
    {
      $x=0;
      while(list($k,$d)=each($SITE_MENU))
      {
	if(ereg("^[0-9]$",$k))
	  $dat=$d;
	else
	  $dat=$k;
	$p[$dat]=pow(2,$x);
	//print "~~$dat=".$p[$dat]."--".count($p)."==".pow(2,$x)."<br>\n";
	$x++;
      }
      $p["admin"]=pow(2,$x);
      //while(list($k,$d)=each($p))
	//print "~~$k=$d<br>\n";
      $this->permissions=$p;
    }
  }
  
  function perm_invalid($does_have, $must_have)
  {
    global $perm, $auth, $sess;
    
    include("lib/perminvalid.inc");
  }
  
  function is_perm($haystack,$needle)
  {
    $haystackperm = split(",", $haystack);
    $needleperm = split(",", $needle);
    
    list ($ok0, $haystackbits) = $this->permsum($haystackperm);
    list ($ok1, $needlebits) = $this->permsum($needleperm);
    $has_all = (($haystackbits & $needlebits) != 0);
    if (!($has_all && $ok0 && $ok1) ) 
    {
      return false;
    }
    else 
    {
      return true;
    }
  }

  // returns some checkboxes which can be used in place of perm_sel
  function perm_checkbox($name, $current = "", $class = "") {
	  reset($this->permissions);
	  while(list($k, $v) = each($this->permissions)) {
		  $ret .= sprintf("<input type=\"checkbox\" multiple name=\"%s[]\" %s value=\"%s\" %s >%s<br>\n",
						 $name,
						 ($class!="")?" class=\"$class\"":"",
						 $k,
						 $this->perm_islisted($current,$k)?" checked":"",
						 $k );
	  }
	  $ret .= "</select>";
	  return $ret;
  }
  // returns a list (in html) of permissions in $current
  function perm_show_list($current="", $class = "") {
	  if (empty($current)){
		  return "";
	  }
	  $permissions = split(",", $current);
	  reset($permissions);
	  $ret = "<ul>\n";
	  while(list($k, $v) = each($permissions)) {
		  $ret .= "  <li>$v</li>\n";
	  }
	  $ret .= "</ul>";
	  return $ret;
  }

  // checks permissions, print error message if you dont have $perm permissions
  // returns true if allowed, false if not allowed
  function check_nohalt($must_have)
  {
	  global $auth;
	  if (! $this->have_perm($must_have)) {
		  if (! isset($auth->auth["perm"]) ) {
			  $auth->auth["perm"] = "";
		  }
		  $does_have = $auth->auth["perm"];
		  include ("lib/perminvalid_msg.inc");
		  return false;
	  }
	  return true;
  }

}


class rimps_session_sql extends CT_Sql
{
  var $classname = "rimps_session_sql";
  var $database_class = "rimpsDB";
  var $database_table = "active_sessions";
}

class rimpsSess extends Session
{
  var $classname = "rimpsSess";
  var $that_class = "rimps_session_sql";
  
  var $mode = "cookie";
  var $lifetime = 0;
  var $allowcache = "yes";
  var $allowcache_expire = 60;
  var $auto_init = "lib/auto_init.inc";
}

?>
