<?
// Functions to help play songs
function getBaseDir($location){
	// Takes an location ID and returns the base dir.  Also
	// caches the values in the global $locationCache.  If the value
	// has previously been cached, the database lookup is skipped and the
	// value immediately returned.
	global $locationCache;
	if (($basedir=$locationCache) == ''){
		$db = new rimpsDB;
		$sql = "SELECT basedir FROM mp3location WHERE id = $location";
		$basedir = $db->simple_query($sql);
	}
	return $basedir;
}

function getClientAccessPaths($songIDs){
	// Takes an array of songIDs and returns an array of access
	// paths to the songs valid for the current client.
	if (is_array($songIDs)){
		$songList = implode(',', $songIDs);
	}
	else{
		$songList = $songIDs;
	}
		
	$db = new rimpsDB;	
	
	// Get songs and mount_points for the connecting client
	$sql = "SELECT m.id, m.loc_id, m.filename, n.mount_point FROM mp3data m, network_mappings n ".
		"WHERE n.loc_id = m.loc_id AND n.clients LIKE '%|".$GLOBALS["clientGroup"]."|%' ".
		"AND m.id in (".$songList.")";
	msg("sql: $sql");
	$db->query($sql);
	buildPathArray($db, $pathArray);

	// Fill in the cracks with any "default" mount_points in case there are songs from locations
	// which have not been specifically configured for the requesting client
	$sql = "SELECT m.id, m.loc_id, m.filename, n.mount_point FROM mp3data m, network_mappings n ".
		"WHERE n.loc_id = m.loc_id AND n.is_default =1 ".
		"AND m.id in (".$songList.")";	
	$db->query($sql);
	buildPathArray($db, $pathArray);
	
	return $pathArray;
}

function buildPathArray($db, &$pathArray){
	// Takes a database object $db and a an array by reference.  The function then
	// modifies the array to contain a list of songIDs as the index and the path
	// as a value.  Note that subsequent calls to this function will NOT overwrite previous
	// results.  Only results which were not available the previous time the fuction was called
	// will be added to the $pathArray
	
	while($db->next_record()){
		if ($pathArray[$db->f('id')]==''){
			$basedir = getBaseDir($db->f('loc_id'));
			$mount_point = $db->f('mount_point');
			msg("mount_point: $mount_point");
			$path = str_replace($basedir, $mount_point, $db->f('filename'));
			if (strToLower(substr($path, 0, 4))=='http'){
				$path = str_replace(' ', '%20', $path);
			}
			//echo "path: $path<br>\n";
			//echo "basedir: $basedir<br>";
			//echo "mount: $mount<br>";
			//echo "filename: ".$db->f('filename')."<br>";
			$pathArray[$db->f('id')] = $path;
		}
	}
}

?>
