<?
// Tar functions

function blockPad($string){
	// pads a string with null characters to create a complete block of 512 chars
	$null = chr(0);
	while(strlen($string)%512!=0){
		$string .= $null;
	}
	return $string;
}

function checksum($string){
	$len = strlen($string);
	for ($i=0; $i<$len; $i++){
		$counter++;
		$char = substr($string, $i, 1);
		//echo "Char: $char";
		$sum += ord($char);
	}
	return decoct($sum);
}

function createTar($fileArray, $baseDir='', $includeDirInfo='N', $output=''){
	// Creates a tar file from the files in $fileArray using $baseDir as the base
	// directory.  If includeDirInfo is set to 'Y', the tar file will be built with
	// the directory information (note that $baseDir will NEVER be included in the 
	// tar file).  If $output is set, the resulting tar file will be written to the 
	// filename defined in $output.  Otherwise the tar file will be output to STDOUT
	//
	// Note: uid, gid, checksum, mode, link, and linkname among many other header
	// properties still needs to be implemented.
	
	if ($output != ''){
		$ofile = fopen($output, 'wb');
		if (!ofile){
			return "Error:  Unable to open file $output";
		}
	}
	// Iterate through all the files
	reset($fileArray);
	while (list($temp, $filename) = each($fileArray)){
		// Set name to either including directory info or not depending on how 
		// $includeDirInfo is set
		if (strToUpper($includeDirInfo) == 'Y'){
			$name = $filename;
		}
		else{
			$name = basename($filename);
		}
		
		// Construct the full filename
		if ($baseDir){
			$filename = "$baseDir/$filename";
		}
		
		// Set some header parameters
		$size = decOct(filesize($filename));
		$mtime = decOct(filemtime($filename));
		$chksum = '        ';

		// Edit these header parameters as desired
		$mode = '';
		$uid = '';
		$gid = '';
		$link = '0';
		$linkname = '';
		$magic = '';
		$version = '';
		$uname = 'nobody';
		$gname = '';
		$devmajor = '';
		$devminor = '';
		$prefix = '';
		
		$null = chr(0);
		
		// Build header so we can calculate checksum
		$header = sprintf("%'$null-100s%'$null-8s%'$null-8s%'$null-8s%'$null-12s%'$null-12s%'$null-8s%'$null-1s%'$null-100s%'$null-6s%'$null-2s%'$null-32s%'$null-32s%'$null-8s%'$null-8s%'$null-155s",$name, $mode, $uid, $gid, $size, $mtime, $chksum, $link, $linkname, $magic, $version, $uname, $gname, $devmajor, $devminor, $prefix );
		$header = blockPad($header);
		
		// Compute Checksum
		$chksum = checksum($header);
				
		// Build the header again with the checksum in the appropriate field
		$header = sprintf("%'$null-100s%'$null-8s%'$null-8s%'$null-8s%'$null-12s%'$null-12s%'$null-8s%'$null-1s%'$null-100s%'$null-6s%'$null-2s%'$null-32s%'$null-32s%'$null-8s%'$null-8s%'$null-155s",$name, $mode, $uid, $gid, $size, $mtime, $chksum, $link, $linkname, $magic, $version, $uname, $gname, $devmajor, $devminor, $prefix );
		$header = blockPad($header);
		
		if ($ofile){
			fwrite($ofile, $header);
		}
		else{
			echo $header;
		}
		
		// Header is written, now write out the file
		$written = 0;
		$rfile = fopen($filename, 'rb');
		if ($rfile){
			$buffer = '';
			$written=0;
			while (!feof($rfile)){
				$buffer = fread($rfile, 512);
				$written += strlen($buffer);
				if ($ofile){
					fwrite($ofile, $buffer);
				}
				else{
					echo $buffer;
				}
			}
			// Finish off the block
			if ($written%512 != 0){
				$repeats = 512 - ($written%512);
			}
			else{
				$repeats =0;
			}
			$blockEnd = '';
			for ($i=0; $i<$repeats; $i++){
				$blockEnd .=$null;
			}
			
			if ($ofile){
				fwrite($ofile, $blockEnd);
			}
			else{
				echo $blockEnd;
			}
			fclose($rfile);
		}
		else{
			$errors .= "Error: $filename could not be opened\n";
		}
	}
	// Add on two empty blocks
	for ($i=0; $i<=1024; $i++){
		$blockEnd .= $null;
	}
	if ($ofile){
		fwrite($ofile, $blockEnd);
		fclose($ofile);
	}
	else{
		echo $blockEnd;
	}
	return $errors;
}

?>